Index: trunk/source/processes/electromagnetic/standard/include/G4ionIonisation.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4ionIonisation.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4ionIonisation.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4ionIonisation.hh,v 1.56 2008/09/14 17:11:48 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4ionIonisation.hh,v 1.57 2009/02/20 12:06:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -85,5 +85,5 @@
   virtual ~G4ionIonisation();
 
-  inline G4bool IsApplicable(const G4ParticleDefinition& p);
+  virtual G4bool IsApplicable(const G4ParticleDefinition& p);
 
   // Print out of the class parameters
@@ -102,5 +102,5 @@
 					   const G4ParticleDefinition*);
 
-  inline G4double MinPrimaryEnergy(const G4ParticleDefinition* p,
+  virtual G4double MinPrimaryEnergy(const G4ParticleDefinition* p,
 				   const G4Material*, G4double cut);
 
@@ -127,21 +127,4 @@
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4bool G4ionIonisation::IsApplicable(const G4ParticleDefinition& p)
-{
-  return (p.GetPDGCharge() != 0.0 && !p.IsShortLived() &&
-          p.GetParticleType() == "nucleus");
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4double G4ionIonisation::MinPrimaryEnergy(
-          const G4ParticleDefinition* p, const G4Material*, G4double cut)
-{
-  return 
-    p->GetPDGMass()*(std::sqrt(1. + 0.5*cut/CLHEP::electron_mass_c2) - 1.0);
-}
-
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
Index: trunk/source/processes/electromagnetic/standard/src/G4BetheBlochModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4BetheBlochModel.cc	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/src/G4BetheBlochModel.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BetheBlochModel.cc,v 1.24 2008/10/22 16:00:57 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4BetheBlochModel.cc,v 1.31 2009/04/24 14:24:00 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -65,5 +65,4 @@
 #include "G4EmCorrections.hh"
 #include "G4ParticleChangeForLoss.hh"
-#include "G4NistManager.hh"
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -83,5 +82,8 @@
 {
   fParticleChange = 0;
-  if(p) SetParticle(p);
+  if(p) {
+    SetGenericIon(p);
+    SetParticle(p);
+  }
   theElectron = G4Electron::Electron();
   corr = G4LossTableManager::Instance()->EmCorrections();  
@@ -108,53 +110,18 @@
                                    const G4DataVector&)
 {
-  if (!particle) SetParticle(p);
+  SetGenericIon(p);
+  SetParticle(p);
+
+  //G4cout << "G4BetheBlochModel::Initialise for " << p->GetParticleName()
+  //	 << "  isIon= " << isIon 
+  //	 << G4endl;
 
   corrFactor = chargeSquare;
+  // always false before the run
+  SetDeexcitationFlag(false);
 
   if(!isInitialised) {
     isInitialised = true;
-
-    if(!fParticleChange) {
-      if (pParticleChange) {
-	fParticleChange = reinterpret_cast<G4ParticleChangeForLoss*>
-	  (pParticleChange);
-      } else { 
-	fParticleChange = new G4ParticleChangeForLoss();
-      }
-    }
-  }
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-void G4BetheBlochModel::SetParticle(const G4ParticleDefinition* p)
-{
-  if(particle != p) {
-    particle = p;
-    G4String pname = particle->GetParticleName();
-    if (particle->GetParticleType() == "nucleus" &&
-	pname != "deuteron" && pname != "triton") {
-      isIon = true;
-    }
-    
-    mass = particle->GetPDGMass();
-    spin = particle->GetPDGSpin();
-    G4double q = particle->GetPDGCharge()/eplus;
-    chargeSquare = q*q;
-    ratio = electron_mass_c2/mass;
-    G4double magmom = particle->GetPDGMagneticMoment()
-      *mass/(0.5*eplus*hbar_Planck*c_squared);
-    magMoment2 = magmom*magmom - 1.0;
-    formfact = 0.0;
-    if(particle->GetLeptonNumber() == 0) {
-      G4double x = 0.8426*GeV;
-      if(spin == 0.0 && mass < GeV) {x = 0.736*GeV;}
-      else if(mass > GeV) {
-        x /= nist->GetZ13(mass/proton_mass_c2);
-	//	tlimit = 51.2*GeV*A13[iz]*A13[iz];
-      }
-      formfact = 2.0*electron_mass_c2/(x*x);
-      tlimit   = 2.0/formfact;
-    }
+    fParticleChange = GetParticleChangeForLoss();
   }
 }
@@ -415,4 +382,5 @@
   G4double cost = deltaKinEnergy * (totEnergy + electron_mass_c2) /
                                    (deltaMomentum * totMomentum);
+  /*
   if(cost > 1.0) {
     G4cout << "### G4BetheBlochModel WARNING: cost= " 
@@ -429,4 +397,5 @@
     cost = 1.0;
   }
+  */
   G4double sint = sqrt((1.0 - cost)*(1.0 + cost));
 
@@ -440,5 +409,5 @@
   // create G4DynamicParticle object for delta ray
   G4DynamicParticle* delta = new G4DynamicParticle(theElectron,
-                                                 deltaDirection,deltaKinEnergy);
+						   deltaDirection,deltaKinEnergy);
 
   vdp->push_back(delta);
@@ -453,3 +422,16 @@
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+G4double G4BetheBlochModel::MaxSecondaryEnergy(const G4ParticleDefinition* pd,
+					       G4double kinEnergy) 
+{
+  // here particle type is checked for any method
+  SetParticle(pd);
+  G4double tau  = kinEnergy/mass;
+  G4double tmax = 2.0*electron_mass_c2*tau*(tau + 2.) /
+                  (1. + 2.0*(tau + 1.)*ratio + ratio*ratio);
+  return std::min(tmax,tlimit);
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/source/processes/electromagnetic/standard/src/G4BetheHeitlerModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4BetheHeitlerModel.cc	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/src/G4BetheHeitlerModel.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BetheHeitlerModel.cc,v 1.12 2008/10/15 15:54:57 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4BetheHeitlerModel.cc,v 1.13 2009/04/09 18:41:18 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -94,11 +94,5 @@
 				     const G4DataVector&)
 {
-  if(!fParticleChange) {
-    if(pParticleChange) {
-      fParticleChange = reinterpret_cast<G4ParticleChangeForGamma*>(pParticleChange);
-    } else {
-      fParticleChange = new G4ParticleChangeForGamma();
-    }
-  }
+  if(!fParticleChange) fParticleChange = GetParticleChangeForGamma();
 
   if(theCrossSectionTable) {
Index: trunk/source/processes/electromagnetic/standard/src/G4BohrFluctuations.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4BohrFluctuations.cc	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/src/G4BohrFluctuations.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BohrFluctuations.cc,v 1.6 2007/09/27 14:02:41 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4BohrFluctuations.cc,v 1.7 2009/02/19 19:17:50 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -137,3 +137,22 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
+G4double G4BohrFluctuations::Dispersion(const G4Material* material,
+					const G4DynamicParticle* dp,
+					G4double& tmax,
+					G4double& length)
+{
+  if(!particle) InitialiseMe(dp->GetDefinition());
 
+  G4double electronDensity = material->GetElectronDensity();
+  kineticEnergy = dp->GetKineticEnergy();
+  G4double etot = kineticEnergy + particleMass;
+  beta2 = kineticEnergy*(kineticEnergy + 2.0*particleMass)/(etot*etot);
+  G4double siga  = (1.0/beta2 - 0.5) * twopi_mc2_rcl2 * tmax * length
+                 * electronDensity * chargeSquare;
+
+  return siga;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+
Index: trunk/source/processes/electromagnetic/standard/src/G4BraggIonModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4BraggIonModel.cc	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/src/G4BraggIonModel.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BraggIonModel.cc,v 1.22 2008/10/22 16:00:57 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4BraggIonModel.cc,v 1.24 2009/04/09 18:41:18 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -114,4 +114,7 @@
   corrFactor = chargeSquare;
 
+  // always false before the run
+  SetDeexcitationFlag(false);
+
   if(!isInitialised) {
     isInitialised = true;
@@ -123,12 +126,5 @@
     corr = G4LossTableManager::Instance()->EmCorrections();
 
-    if(!fParticleChange) {
-      if(pParticleChange) {
-	fParticleChange = 
-	  reinterpret_cast<G4ParticleChangeForLoss*>(pParticleChange);
-      } else {
-	fParticleChange = new G4ParticleChangeForLoss();
-      }
-    }
+    fParticleChange = GetParticleChangeForLoss();
   }
 }
@@ -352,4 +348,16 @@
   fParticleChange->SetProposedKineticEnergy(kineticEnergy);
   fParticleChange->SetProposedMomentumDirection(finalP);
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
+
+G4double G4BraggIonModel::MaxSecondaryEnergy(const G4ParticleDefinition* pd,
+					     G4double kinEnergy)
+{
+  if(pd != particle) SetParticle(pd);
+  G4double tau  = kinEnergy/mass;
+  G4double tmax = 2.0*electron_mass_c2*tau*(tau + 2.) /
+                  (1. + 2.0*(tau + 1.)*ratio + ratio*ratio);
+  return tmax;
 }
 
Index: trunk/source/processes/electromagnetic/standard/src/G4BraggModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4BraggModel.cc	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/src/G4BraggModel.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BraggModel.cc,v 1.20 2008/10/22 16:01:46 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4BraggModel.cc,v 1.22 2009/04/09 18:41:18 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -112,4 +112,7 @@
   if(p != particle) SetParticle(p);
 
+  // always false before the run
+  SetDeexcitationFlag(false);
+
   if(!isInitialised) {
     isInitialised = true;
@@ -121,10 +124,5 @@
     corr = G4LossTableManager::Instance()->EmCorrections();
 
-    if(pParticleChange) {
-      fParticleChange = 
-	reinterpret_cast<G4ParticleChangeForLoss*>(pParticleChange);
-    } else {
-      fParticleChange = new G4ParticleChangeForLoss();
-    }
+    fParticleChange = GetParticleChangeForLoss();
   }
 }
@@ -337,4 +335,16 @@
 
   vdp->push_back(delta);
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
+
+G4double G4BraggModel::MaxSecondaryEnergy(const G4ParticleDefinition* pd,
+					  G4double kinEnergy)
+{
+  if(pd != particle) SetParticle(pd);
+  G4double tau  = kinEnergy/mass;
+  G4double tmax = 2.0*electron_mass_c2*tau*(tau + 2.) /
+                  (1. + 2.0*(tau + 1.)*ratio + ratio*ratio);
+  return tmax;
 }
 
Index: trunk/source/processes/electromagnetic/standard/src/G4ComptonScattering.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4ComptonScattering.cc	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/src/G4ComptonScattering.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4ComptonScattering.cc,v 1.30 2008/10/15 17:53:44 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4ComptonScattering.cc,v 1.31 2009/02/20 12:06:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // 
@@ -84,4 +84,11 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
+G4bool G4ComptonScattering::IsApplicable(const G4ParticleDefinition& p)
+{
+  return (&p == G4Gamma::Gamma());
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
 void G4ComptonScattering::InitialiseProcess(const G4ParticleDefinition*)
 {
Index: trunk/source/processes/electromagnetic/standard/src/G4CoulombScattering.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4CoulombScattering.cc	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/src/G4CoulombScattering.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4CoulombScattering.cc,v 1.19 2008/10/15 17:53:44 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4CoulombScattering.cc,v 1.20 2009/02/20 12:06:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -79,4 +79,11 @@
 G4CoulombScattering::~G4CoulombScattering()
 {}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+G4bool G4CoulombScattering::IsApplicable(const G4ParticleDefinition& p)
+{
+  return (p.GetPDGCharge() != 0.0 && !p.IsShortLived());
+}
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
Index: trunk/source/processes/electromagnetic/standard/src/G4CoulombScatteringModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4CoulombScatteringModel.cc	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/src/G4CoulombScatteringModel.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4CoulombScatteringModel.cc,v 1.37 2008/07/31 13:11:34 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4CoulombScatteringModel.cc,v 1.39 2009/05/10 16:09:29 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -93,5 +93,5 @@
 
   // CM system
-  G4int iz      = G4int(Z);
+  iz            = G4int(Z);
   G4double m2   = fNistManager->GetAtomicMassAmu(iz)*amu_c2;
   G4double etot = tkin + mass;
@@ -137,5 +137,5 @@
 
   G4double Z  = currentElement->GetZ();
-  G4int iz    = G4int(Z);
+  iz          = G4int(Z);
   G4int ia    = SelectIsotopeNumber(currentElement);
   G4double m2 = theParticleTable->GetIonTable()->GetNucleusMass(iz, ia);
@@ -182,9 +182,6 @@
   // recoil
   G4double erec = kinEnergy - ekin;
-  G4double th = 
-    std::min(recoilThreshold,
-	     Z*currentElement->GetIonisation()->GetMeanExcitationEnergy());
 
-  if(erec > th) {
+  if(erec > recoilThreshold) {
     G4ParticleDefinition* ion = theParticleTable->FindIon(iz, ia, 0, iz);
     G4double plab = sqrt(ekin*(ekin + 2.0*mass));
Index: trunk/source/processes/electromagnetic/standard/src/G4GammaConversion.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4GammaConversion.cc	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/src/G4GammaConversion.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4GammaConversion.cc,v 1.30 2008/10/15 17:53:44 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4GammaConversion.cc,v 1.31 2009/02/20 12:06:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // 
@@ -90,4 +90,11 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
+G4bool G4GammaConversion::IsApplicable(const G4ParticleDefinition& p)
+{
+  return (&p == G4Gamma::Gamma());
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
 void G4GammaConversion::InitialiseProcess(const G4ParticleDefinition*)
 {
Index: trunk/source/processes/electromagnetic/standard/src/G4IonFluctuations.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4IonFluctuations.cc	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/src/G4IonFluctuations.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4IonFluctuations.cc,v 1.24 2008/10/22 16:25:21 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4IonFluctuations.cc,v 1.26 2009/03/31 13:24:40 toshito Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -190,14 +190,16 @@
 
   // heavy ion correction
-  G4double f1 = 1.065e-4*chargeSquare;
-  if(beta2 > theBohrBeta2)  f1/= beta2;
-  else                      f1/= theBohrBeta2;
-  if(f1 > 2.5) f1 = 2.5;
-  fac *= (1.0 + f1);
+//  G4double f1 = 1.065e-4*chargeSquare;
+//  if(beta2 > theBohrBeta2)  f1/= beta2;
+//  else                      f1/= theBohrBeta2;
+//  if(f1 > 2.5) f1 = 2.5;
+//  fac *= (1.0 + f1);
 
   // taking into account the cut
-  if(fac > 1.0) {
-    siga *= (1.0 + (fac - 1.0)*2.0*electron_mass_c2*beta2/(tmax*(1.0 - beta2)));
-  }
+  G4double fac_cut = 1.0 + (fac - 1.0)*2.0*electron_mass_c2*beta2/(tmax*(1.0 - beta2));
+  if(fac_cut > 0.01 && fac > 0.01) {
+    siga *= fac_cut;
+  }
+
   //G4cout << "siga(keV)= " << sqrt(siga)/keV << " fac= " << fac 
   //	 << "  f1= " << f1 << G4endl;
@@ -420,2 +422,17 @@
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+void G4IonFluctuations::SetParticleAndCharge(const G4ParticleDefinition* part,
+					     G4double q2)
+{
+  if(part != particle) {
+    particle       = part;
+    particleMass   = part->GetPDGMass();
+    charge         = part->GetPDGCharge()/eplus;
+    chargeSquare   = charge*charge;
+  }
+  effChargeSquare  = q2;
+  uniFluct.SetParticleAndCharge(part, q2);
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
Index: trunk/source/processes/electromagnetic/standard/src/G4KleinNishinaCompton.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4KleinNishinaCompton.cc	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/src/G4KleinNishinaCompton.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4KleinNishinaCompton.cc,v 1.9 2007/05/22 17:34:36 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4KleinNishinaCompton.cc,v 1.10 2009/05/15 17:12:33 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -79,8 +79,5 @@
                                        const G4DataVector&)
 {
-  if(pParticleChange)
-    fParticleChange = reinterpret_cast<G4ParticleChangeForGamma*>(pParticleChange);
-  else
-    fParticleChange = new G4ParticleChangeForGamma();
+  fParticleChange = GetParticleChangeForGamma();
 }
 
Index: trunk/source/processes/electromagnetic/standard/src/G4MollerBhabhaModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4MollerBhabhaModel.cc	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/src/G4MollerBhabhaModel.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4MollerBhabhaModel.cc,v 1.30 2007/05/22 17:34:36 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4MollerBhabhaModel.cc,v 1.34 2009/04/24 17:15:46 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -74,8 +74,9 @@
                                          const G4String& nam)
   : G4VEmModel(nam),
-  particle(0),
-  isElectron(true),
-  twoln10(2.0*log(10.0)),
-  lowLimit(0.2*keV)
+    particle(0),
+    isElectron(true),
+    twoln10(2.0*log(10.0)),
+    lowLimit(0.2*keV),
+    isInitialised(false)
 {
   theElectron = G4Electron::Electron();
@@ -87,12 +88,4 @@
 G4MollerBhabhaModel::~G4MollerBhabhaModel()
 {}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-void G4MollerBhabhaModel::SetParticle(const G4ParticleDefinition* p)
-{
-  particle = p;
-  if(p != theElectron) isElectron = false;
-}
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -108,13 +101,24 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
+G4double G4MollerBhabhaModel::MaxSecondaryEnergy(const G4ParticleDefinition*,
+						 G4double kinEnergy) 
+{
+  G4double tmax = kinEnergy;
+  if(isElectron) tmax *= 0.5;
+  return tmax;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
+
 void G4MollerBhabhaModel::Initialise(const G4ParticleDefinition* p,
                                      const G4DataVector&)
 {
   if(!particle) SetParticle(p);
-  if(pParticleChange)
-    fParticleChange = reinterpret_cast<G4ParticleChangeForLoss*>
-                                                     (pParticleChange);
-  else
-    fParticleChange = new G4ParticleChangeForLoss();
+  SetDeexcitationFlag(false);
+
+  if(isInitialised) return;
+
+  isInitialised = true;
+  fParticleChange = GetParticleChangeForLoss();
 }
 
@@ -289,8 +293,10 @@
 					    G4double maxEnergy)
 {
-  G4double tmax = std::min(maxEnergy, MaxSecondaryKinEnergy(dp));
+  G4double kineticEnergy = dp->GetKineticEnergy();
+  G4double tmax = kineticEnergy;
+  if(isElectron) tmax *= 0.5;
+  if(maxEnergy < tmax) tmax = maxEnergy;
   if(tmin >= tmax) return;
 
-  G4double kineticEnergy = dp->GetKineticEnergy();
   G4double energy = kineticEnergy + electron_mass_c2;
   G4double totalMomentum = sqrt(kineticEnergy*(energy + electron_mass_c2));
@@ -339,23 +345,11 @@
     G4double b3  = b4 + y122;
 
-    y     = xmax*xmax;
-    grej  = -xmin*b1;
-    grej += y*b2;
-    grej -= xmin*xmin*xmin*b3;
-    grej += y*y*b4;
-    grej *= beta2;
-    grej += 1.0;
+    y    = xmax*xmax;
+    grej = 1.0 + (y*y*b4 - xmin*xmin*xmin*b3 + y*b2 - xmin*b1)*beta2; 
     do {
-      q  = G4UniformRand();
-      x  = xmin*xmax/(xmin*(1.0 - q) + xmax*q);
-      z  = -x*b1;
-      y  = x*x;
-      z += y*b2;
-      y *= x;
-      z -= y*b3;
-      y *= x;
-      z += y*b4;
-      z *= beta2;
-      z += 1.0;
+      q = G4UniformRand();
+      x = xmin*xmax/(xmin*(1.0 - q) + xmax*q);
+      y = x*x;
+      z = 1.0 + (y*y*b4 - x*y*b3 + y*b2 - x*b1)*beta2; 
       /*
       if(z > grej) {
@@ -396,5 +390,5 @@
   // create G4DynamicParticle object for delta ray
   G4DynamicParticle* delta = new G4DynamicParticle(theElectron,
-						 deltaDirection,deltaKinEnergy);
+						   deltaDirection,deltaKinEnergy);
   vdp->push_back(delta);
 }
Index: trunk/source/processes/electromagnetic/standard/src/G4MscModel71.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4MscModel71.cc	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/src/G4MscModel71.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4MscModel71.cc,v 1.6 2008/03/13 17:20:07 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4MscModel71.cc,v 1.7 2009/04/09 18:41:18 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -140,5 +140,5 @@
 
   if(pParticleChange)
-    fParticleChange = reinterpret_cast<G4ParticleChangeForMSC*>(pParticleChange);
+    fParticleChange = static_cast<G4ParticleChangeForMSC*>(pParticleChange);
   else
     fParticleChange = new G4ParticleChangeForMSC();
Index: trunk/source/processes/electromagnetic/standard/src/G4PAIModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4PAIModel.cc	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/src/G4PAIModel.cc	(revision 1055)
@@ -24,4 +24,10 @@
 // ********************************************************************
 //
+// $Id: G4PAIModel.cc,v 1.47 2009/04/09 18:41:18 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+//
+// -------------------------------------------------------------------
+//
+// GEANT4 Class
 // File name:     G4PAIModel.cc
 //
@@ -153,8 +159,5 @@
 						 fTotBin);
 
-  if(pParticleChange)
-    fParticleChange = reinterpret_cast<G4ParticleChangeForLoss*>(pParticleChange);
-  else
-    fParticleChange = new G4ParticleChangeForLoss();
+  fParticleChange = GetParticleChangeForLoss();
 
   // Prepare initialization
@@ -177,4 +180,7 @@
       fCutCouple = theCoupleTable->GetMaterialCutsCouple( fMaterial, 
 					  curReg->GetProductionCuts() );
+      //G4cout << "Reg <" <<curReg->GetName() << ">  mat <" 
+      //	     << fMaterial->GetName() << ">  fCouple= " 
+      //	     << fCutCouple<<G4endl;
       if( fCutCouple ) {
 	fMaterialCutsCoupleVector.push_back(fCutCouple);
@@ -197,4 +203,9 @@
   }
 }
+
+//////////////////////////////////////////////////////////////////
+
+void G4PAIModel::InitialiseMe(const G4ParticleDefinition*) 
+{}
 
 //////////////////////////////////////////////////////////////////
@@ -393,5 +404,6 @@
   {
     //  if ( x1 == x2  ) dNdxCut = y1 + (y2 - y1)*G4UniformRand() ;
-    if ( std::abs(x1-x2) <= eV  ) dNdxCut = y1 + (y2 - y1)*G4UniformRand() ;
+    //    if ( std::abs(x1-x2) <= eV  ) dNdxCut = y1 + (y2 - y1)*G4UniformRand() ;
+    if ( std::abs(x1-x2) <= eV  ) dNdxCut = y1 + (y2 - y1)*0.5 ;
     else             dNdxCut = y1 + (transferCut - x1)*(y2 - y1)/(x2 - x1) ;      
   }
@@ -435,5 +447,6 @@
   {
     //  if ( x1 == x2  ) dEdxCut = y1 + (y2 - y1)*G4UniformRand() ;
-    if ( std::abs(x1-x2) <= eV  ) dEdxCut = y1 + (y2 - y1)*G4UniformRand() ;
+    //    if ( std::abs(x1-x2) <= eV  ) dEdxCut = y1 + (y2 - y1)*G4UniformRand() ;
+    if ( std::abs(x1-x2) <= eV  ) dEdxCut = y1 + (y2 - y1)*0.5 ;
     else             dEdxCut = y1 + (transferCut - x1)*(y2 - y1)/(x2 - x1) ;      
   }
@@ -444,15 +457,20 @@
 //////////////////////////////////////////////////////////////////////////////
 
-G4double G4PAIModel::ComputeDEDX(const G4MaterialCutsCouple* matCC,
-                                 const G4ParticleDefinition* p,
-                                       G4double kineticEnergy,
-                                       G4double cutEnergy)
+G4double G4PAIModel::ComputeDEDXPerVolume(const G4Material*,
+					  const G4ParticleDefinition* p,
+					  G4double kineticEnergy,
+					  G4double cutEnergy)
 {
   G4int iTkin,iPlace;
   size_t jMat;
+  
+  //G4double cut = std::min(MaxSecondaryEnergy(p, kineticEnergy), cutEnergy);
+  G4double cut = cutEnergy;
+
   G4double massRatio  = fMass/p->GetPDGMass();
   G4double scaledTkin = kineticEnergy*massRatio;
   G4double charge     = p->GetPDGCharge();
-  G4double charge2    = charge*charge, dEdx;
+  G4double charge2    = charge*charge;
+  const G4MaterialCutsCouple* matCC = CurrentCouple();
 
   for( jMat = 0 ;jMat < fMaterialCutsCoupleVector.size() ; ++jMat )
@@ -470,6 +488,5 @@
   iPlace = iTkin - 1;
   if(iPlace < 0) iPlace = 0;
-  dEdx = charge2*( (*fdEdxVector)(iPlace) - GetdEdxCut(iPlace,cutEnergy) ) ;  
-
+  G4double dEdx = charge2*( (*fdEdxVector)(iPlace) - GetdEdxCut(iPlace,cut) );
   if( dEdx < 0.) dEdx = 0.;
   return dEdx;
@@ -478,17 +495,19 @@
 /////////////////////////////////////////////////////////////////////////
 
-G4double G4PAIModel::CrossSection( const G4MaterialCutsCouple* matCC,
-                                   const G4ParticleDefinition* p,
-                                         G4double kineticEnergy,
-                                         G4double cutEnergy,
-                                         G4double maxEnergy  ) 
+G4double G4PAIModel::CrossSectionPerVolume( const G4Material*,
+					    const G4ParticleDefinition* p,
+					    G4double kineticEnergy,
+					    G4double cutEnergy,
+					    G4double maxEnergy  ) 
 {
   G4int iTkin,iPlace;
   size_t jMat;
-  G4double tmax = min(MaxSecondaryEnergy(p, kineticEnergy), maxEnergy);
+  G4double tmax = std::min(MaxSecondaryEnergy(p, kineticEnergy), maxEnergy);
+  if(tmax <= cutEnergy) return 0.0;
   G4double massRatio  = fMass/p->GetPDGMass();
   G4double scaledTkin = kineticEnergy*massRatio;
   G4double charge     = p->GetPDGCharge();
   G4double charge2    = charge*charge, cross, cross1, cross2;
+  const G4MaterialCutsCouple* matCC = CurrentCouple();
 
   for( jMat = 0 ;jMat < fMaterialCutsCoupleVector.size() ; ++jMat )
@@ -935,4 +954,27 @@
 }
 
+/////////////////////////////////////////////////////////////////////
+
+G4double G4PAIModel::MaxSecondaryEnergy( const G4ParticleDefinition* p,
+					 G4double kinEnergy) 
+{
+  G4double tmax = kinEnergy;
+  if(p == fElectron) tmax *= 0.5;
+  else if(p != fPositron) { 
+    G4double mass = p->GetPDGMass();
+    G4double ratio= electron_mass_c2/mass;
+    G4double gamma= kinEnergy/mass + 1.0;
+    tmax = 2.0*electron_mass_c2*(gamma*gamma - 1.) /
+                  (1. + 2.0*gamma*ratio + ratio*ratio);
+  }
+  return tmax;
+}
+
+///////////////////////////////////////////////////////////////
+
+void G4PAIModel::DefineForRegion(const G4Region* r) 
+{
+  fPAIRegionVector.push_back(r);
+}
 
 //
